Liferay.Loader.define("segments-web@1.0.59/js/components/criteria_builder/Conjunction.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../../utils/types.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

  var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

  var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

  var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

  var _types = require("../../utils/types.es");

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Conjunction = /*#__PURE__*/function (_React$Component) {
    _inherits(Conjunction, _React$Component);

    function Conjunction() {
      _classCallCheck(this, Conjunction);

      return _possibleConstructorReturn(this, _getPrototypeOf(Conjunction).apply(this, arguments));
    }

    _createClass(Conjunction, [{
      key: "_getConjunctionLabel",
      value: function _getConjunctionLabel(conjunctionName, conjunctions) {
        var conjunction = conjunctions.find(function (_ref) {
          var name = _ref.name;
          return name === conjunctionName;
        });
        return conjunction ? conjunction.label : undefined;
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            className = _this$props.className,
            conjunctionName = _this$props.conjunctionName,
            editing = _this$props.editing,
            onClick = _this$props.onClick,
            supportedConjunctions = _this$props.supportedConjunctions;
        var classnames = (0, _classnames["default"])({
          'btn-sm conjunction-button': editing,
          'conjunction-label': !editing
        }, className);
        return editing ? _react["default"].createElement(_button["default"], {
          className: classnames,
          displayType: "secondary",
          onClick: onClick
        }, this._getConjunctionLabel(conjunctionName, supportedConjunctions)) : _react["default"].createElement("div", {
          className: classnames
        }, this._getConjunctionLabel(conjunctionName, supportedConjunctions));
      }
    }]);

    return Conjunction;
  }(_react["default"].Component);

  var _default = Conjunction;
  exports["default"] = _default;
  //# sourceMappingURL=Conjunction.es.js.map
});
//# sourceMappingURL=Conjunction.es.js.map