Liferay.Loader.define("segments-web@1.0.59/js/components/criteria_builder/ContributorInputs.es", ['module', 'exports', 'require', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../../utils/types.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

  var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

  var _types = require("../../utils/types.es");

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  /**
   * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
   *
   * This library is free software; you can redistribute it and/or modify it under
   * the terms of the GNU Lesser General Public License as published by the Free
   * Software Foundation; either version 2.1 of the License, or (at your option)
   * any later version.
   *
   * This library is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   * details.
   */
  function ContributorInputs(_ref) {
    var contributors = _ref.contributors;
    return contributors.map(function (criteria, i) {
      return _react["default"].createElement(_react["default"].Fragment, {
        key: i
      }, _react["default"].createElement("input", {
        className: "field form-control",
        "data-testid": criteria.inputId,
        id: criteria.inputId,
        name: criteria.inputId,
        readOnly: true,
        type: "hidden",
        value: criteria.query
      }), _react["default"].createElement("input", {
        id: criteria.conjunctionInputId,
        name: criteria.conjunctionInputId,
        readOnly: true,
        type: "hidden",
        value: criteria.conjunctionId
      }));
    });
  }

  var _default = ContributorInputs;
  exports["default"] = _default;
  //# sourceMappingURL=ContributorInputs.es.js.map
});
//# sourceMappingURL=ContributorInputs.es.js.map