Liferay.Loader.define("segments-web@1.0.59/js/components/inputs/SelectEntityInput.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

  var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

  var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  var SelectEntityInput = /*#__PURE__*/function (_React$Component) {
    _inherits(SelectEntityInput, _React$Component);

    function SelectEntityInput() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, SelectEntityInput);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SelectEntityInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

      _defineProperty(_assertThisInitialized(_this), "_handleSelectEntity", function () {
        var _this$props = _this.props,
            onChange = _this$props.onChange,
            _this$props$selectEnt = _this$props.selectEntity,
            id = _this$props$selectEnt.id,
            multiple = _this$props$selectEnt.multiple,
            title = _this$props$selectEnt.title,
            uri = _this$props$selectEnt.uri;

        if (multiple) {
          AUI().use('liferay-item-selector-dialog', function (A) {
            var itemSelectorDialog = new A.LiferayItemSelectorDialog({
              eventName: id,
              on: {
                selectedItemChange: function selectedItemChange(event) {
                  var newVal = event.newVal;

                  if (newVal) {
                    var selectedValues = event.newVal.map(function (item) {
                      return {
                        displayValue: item.name,
                        value: item.id
                      };
                    });
                    onChange(selectedValues);
                  }
                }
              },
              strings: {
                add: Liferay.Language.get('select'),
                cancel: Liferay.Language.get('cancel')
              },
              title: title,
              url: uri
            });
            itemSelectorDialog.open();
          });
        } else {
          Liferay.Util.selectEntity({
            dialog: {
              constrain: true,
              destroyOnHide: true,
              modal: true
            },
            id: id,
            title: title,
            uri: uri
          }, function (event) {
            onChange({
              displayValue: event.entityname,
              value: event.entityid
            });
          });
        }
      });

      return _this;
    }

    _createClass(SelectEntityInput, [{
      key: "render",
      value: function render() {
        var _this$props2 = this.props,
            disabled = _this$props2.disabled,
            displayValue = _this$props2.displayValue,
            value = _this$props2.value;
        return _react["default"].createElement("div", {
          className: "criterion-input input-group select-entity-input"
        }, _react["default"].createElement("div", {
          className: "input-group-item input-group-prepend"
        }, _react["default"].createElement("input", {
          "data-testid": "entity-select-input",
          disabled: disabled,
          type: "hidden",
          value: value
        }), _react["default"].createElement("input", {
          className: "form-control",
          disabled: disabled,
          readOnly: true,
          value: displayValue
        })), _react["default"].createElement("span", {
          className: "input-group-append input-group-item input-group-item-shrink"
        }, _react["default"].createElement(_button["default"], {
          disabled: disabled,
          displayType: "secondary",
          onClick: this._handleSelectEntity
        }, Liferay.Language.get('select'))));
      }
    }]);

    return SelectEntityInput;
  }(_react["default"].Component);

  var _default = SelectEntityInput;
  exports["default"] = _default;
  //# sourceMappingURL=SelectEntityInput.es.js.map
});
//# sourceMappingURL=SelectEntityInput.es.js.map